<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>
</head>
<body>
  <div id="exercises"></div>
  <script>
    let divExercises = document.getElementById('exercises');
    // Ejercicio 1
    // Dado un array de objetos, obtener el objeto con el id 3
    let arrayNames = [
      {id: 1, name: 'Pepe'},
      {id: 2, name: 'Juan'},
      {id: 3, name: 'Alba'},
      {id: 4, name: 'Toby'},
      {id: 5, name: 'Lala'}
    ]
    let name = arrayNames.find(item => item.id===3);
    
    divExercises.innerHTML = `<h1>Ejercicio 1</h1> <p>id: ${name.id}   name: ${name.name}</p>`;
    
    // Ejercicio 2
    // Dado un array de Data, returnedolver un array truthy (sin Data nulos, vacíos, no números, indefinidos o falsos)
    
    let arrayData = [NaN, 0, 5, false, -1, '',undefined, 3, null, 'test']
    
    // let arrayValid = arrayData.filter(item => item ? item.toString().match(/[a-z|A-Z]+/) : null);
    let arrayValid = arrayData.filter(item => !!item);

    divExercises.innerHTML += `<h1>Ejercicio 2</h1> <p>${arrayValid}</p>`;
    
    // Ejercicio 3
    // Dado un array de ciudades, sacar todas las ciudades de España que no sean capitales
    let arrayCities = [
      {city: 'Logroño', country: 'Spain', capital: false},
      {city: 'Paris', country: 'France', capital: true},
      {city: 'Madrid', country: 'Spain', capital: true},
      {city: 'Rome', country: 'Italy', capital: true},
      {city: 'Oslo', country: 'Norway', capital: true},
      {city: 'Jaén', country: 'Spain', capital: false}
    ]
    
    divExercises.innerHTML += `<h1>Ejercicio 3</h1>`;
    arrayCities.filter(item => (item.country === 'Spain' && item.capital === false)).forEach(item => divExercises.innerHTML += "<p> City:" + item.city + "<br/>Country:" + item.country + "<br/>Capital:" + item.capital+ "</p>");
    
    // Ejercicio 4
    // Dado tres arrays de números, sacar en un nuevo array la intersección de estos. 
    let arrayNumber1 = [1,2,3];
    let arrayNumber2 = [1,2,3,4,5];
    let arrayNumber3 = [1,4,7,2];
    
    let myArrayNumber = [...new Set(arrayNumber1.concat(arrayNumber2).concat(arrayNumber3))];
    
    divExercises.innerHTML += `<h1>Ejercicio 4</h1> <p>${myArrayNumber}</p>`;
    
    // Ejercicio 5
    // Dado un array de ciudades, sacar en un nuevo array las ciudades no capitales con unos nuevos parámetros que sean city y isSpain. El valor de isSpain será un booleano indicando si es una ciudad de España.
    // Ejemplo: {city: "Logroño", isSpain: "true"}
    
    arrayCities = [
      {city: 'Logroño', country: 'Spain', capital: false},
      {city: 'Bordeaux', country: 'France', capital: false},
      {city: 'Madrid', country: 'Spain', capital: true},
      {city: 'Florence', country: 'Italy', capital: true},
      {city: 'Oslo', country: 'Norway', capital: true},
      {city: 'Jaén', country: 'Spain', capital: false}
    ]
    let arrayCities2 = [...arrayCities.filter(item => (item.country === 'Spain' && item.capital === false)).map(item => {return{city:item.city, isSpain:true}})];
    
    divExercises.innerHTML += `<h1>Ejercicio 5</h1>`;
    arrayCities2.forEach(item => divExercises.innerHTML += "<p> City:" + item.city + "<br/>isSpain:" + item.isSpain +"</p>");
    
    // Ejercicio 6
    // Crea una función que redondee un número float a un número específico de decimales. 
    // La función debe tener dos parámetros: 
    // Primer parámetro es un número float con x decimales
    // Según parámetro es un int que indique el número de decimales al que redondear
    // Evitar usar el método toFixed()
    // Ejemplo de uso de la función:
    divExercises.innerHTML += "<h1>Ejercicio 6</h1>";
    
    let roundedResult  = roundTo(2.123, 2);
    
    divExercises.innerHTML += `<p>roundTo(2.123, 2):<br/> ${roundedResult}</p><br/>`;
    
    roundedResult  = roundTo(1.123456789, 6);
    
    //El primer parametro es x porque asi es como me pedis que se llame, sino lo hubiese puesto como numero
    function roundTo(x, decimales){
      let decimales2 = Math.pow(10,decimales);
      let bytesAfterPrecision = x * decimales2;
      return parseFloat(Math.round(bytesAfterPrecision)/decimales2);
    }
    
    divExercises.innerHTML += `<p>roundTo(1.123456789, 6):<br/> ${roundedResult}</p>`;
    
    // Ejercicio 7
    // Crea una función que retorne los campos de un objeto que equivalgan a un valor “falsy” después de ser ejecutados por una función específica.
    // La fundación debe tener dos parámetros:
    // Primer parámetro es un objeto con x número de campos y Data
    // Segundo parametro es una funcion que retorne un booleano, que se tiene que aplicar al objeto del primer parámetro
    // Ejemplo de uso de la función:
    
    let result = returnFalsyValues({ a: 1, b: '2', c: 3 }, x => typeof x === 'string');
    
    //El primer parametro es x porque asi es como me pedis que se llame, sino lo hubiese puesto como objeto
    function returnFalsyValues(x, funcionBoolean){
      let falsy = {};
      
      if(!x){
        return falsy;
      }
      
      for(let i in x){
        if(!funcionBoolean(x[i])){
          falsy[i] = x[i];
        }
      }
      
      
      return falsy;
    }
    
    divExercises.innerHTML += "<h1>Ejercicio 7</h1>";
    
    for(let i in result){
      divExercises.innerHTML += `<p>${i}: ${result[i]}</p>`;
    }
    
    
    // Ejercicio 8
    // Crea una función que convierta un número de bytes en un formato con Data legibles ('B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB')
    // La función debe tener 2 parámetros:
    // Primer parámetro debe ser el número de bytes
    // Segundo parámetro debe ser un número especificando la cantidad de dígitos a los que se debe trunch el result (esto se puede hacer con Number.prototype.toPrecision()). Por defecto, este parámetro debe de tener un valor de 3.
    // Ejemplo de uso de la función:
    divExercises.innerHTML += `<h1>Ejercicio 8</h1>`;
    
    let weights = ['B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
    
    result = fromBytesToFormattedSizeUnits(1000);
    // result = fromBytesToFormattedSizeUnits(100);
    // result = fromBytesToFormattedSizeUnits(10000000000);

    divExercises.innerHTML += `<p>fromBytesToFormattedSizeUnits(1000): ${result}</p>`;
    
    result = fromBytesToFormattedSizeUnits(123456789);
    
    divExercises.innerHTML += `<p>fromBytesToFormattedSizeUnits(123456789): ${result}</p>`;
    
    result = fromBytesToFormattedSizeUnits(-12145489451.5932, 5);

    divExercises.innerHTML += `<p>fromBytesToFormattedSizeUnits(-12145489451.5932, 5): ${result}</p>`;
    
    function fromBytesToFormattedSizeUnits(bytes, trunch = 3){
      let bytesAfterPrecision = bytes.toPrecision(trunch).toString().split('e+').join('.').split('.');

      if(bytesAfterPrecision.length === 1){
        return bytes + weights[0];
      }
      else{
        bytesAfterPrecision = Number(bytesAfterPrecision[0]+bytesAfterPrecision[1]);

        let rest = bytes;

        let count = 0;
        let cont = true;
        while(cont){
          rest/=   10;
          if(rest%10 != 0){
            cont = false;
          }
          count++;
        }
        while(count%3 != 0){
          count--;
        }
        count /= 3;
        if(Math.abs(bytes)%10 === 0){
          return bytes/Math.pow(10,(3*count)) + weights[count];
        }
      }
      

      for(let i=1; i < weights.length; i++){
        if(Math.abs(bytesAfterPrecision) < Math.pow(10,(3*i))){
          return bytesAfterPrecision/Math.pow(10,(3*(i-1))) + weights[i+1];
        }
      }

      return bytesAfterPrecision/Math.pow(10,3) + weights[7];
    }

    // Ejercicio 9
    // Crea una función que a partir de un objeto de entrada, retorne un objeto asegurándose que las claves del objeto estén en lowercase.
    // La función debe tener un objeto como único parámetro.
    // Ejemplo de uso de la función:
    let myObject = { NamE: 'Charles', ADDress: 'Home Street' };
    let myObjLowercase = toLowercaseKeys(myObject);
    
    function toLowercaseKeys(myObject){
      let objectReturn = {};
      
      for(let i in myObject){
        objectReturn[i.toLowerCase()] = myObject[i];
      }
      
      return objectReturn;
    }
  
  divExercises.innerHTML += "<h1>Ejercicio 9</h1>";
  for(let i in myObjLowercase){
    divExercises.innerHTML += `<p>${i}: ${myObjLowercase[i]}</p>`;
  }
  
  // Ejercicio 10
  // Crea una función que elimine las etiquetas html o xml de un string.
    // La función debe tener un string como único parámetro.
    // Ejemplo de uso de la función:
    result = removeHTMLTags('<div><span>lorem</span> <strong>ipsum</strong></div>');
    
    function removeHTMLTags(str){
      return str.split(/<.*?>/).join(" ").trim();
    }
    
    divExercises.innerHTML += `<h1>Ejercicio 10</h1> <p>${result}</p>`;
    
    // Ejercicio 11
    // Crea una función que tome un array como parametro y lo divida en arrays nuevos con tantos elementos como sean especificados.
    // La función debe tener dos parámetros:
    // El primer parámetro es el array entero que se quiere dividir.
    // El segundo parámetro es el número de elementos que deben tener los arrays en los que se divida el array original del primer parámetro.
    // Ejemplo de uso de la función:
    result = splitArrayIntoChunks([1, 2, 3, 4, 5, 6, 7], 3);

    function splitArrayIntoChunks(array, divisions){
      let returned = [];
      for(let i=0; i < divisions; i++){
        returned[i] = array.slice((i*divisions),((i+1)*divisions));
      }
      return returned;
    }
    
    divExercises.innerHTML += "<h1>Ejercicio 11</h1> <h4>splitArrayIntoChunks([1, 2, 3, 4, 5, 6, 7], 3) :</h4>";
    for(let i in result){
      divExercises.innerHTML += `<p>${result[i]}</p>`;
    }

    </script>
</body>
</html>